<template>
  <user-center-layout :title="$t('withdrawal')">
    <div v-if="isLoading" class="flex w-full h-full">
      <div v-loading="isLoading" class="w-full px-5 py-32"></div>
    </div>
    <template v-else>
      <div
        v-if="!isBankMethodAvailabled"
        class="px-5 py-32 text-2xl flex justify-center"
      >
        <span>{{ $t("no_available_method_to_do_the_transaction") }}</span>
      </div>
      <template v-else>
        <div
          v-if="!isLoading && !isShowPaymentPasswordDialog"
          class="flex divider-x relative mx-auto"
        >
          <aside class="min-w-[248px] w-3/12">
            <el-scrollbar>
              <div class="p-6 flex flex-col gap-4">
                <nuxt-link
                  v-if="isNormalBankMethodValible && isUfun"
                  id="withdrawalBankTransferOption"
                  to="/withdrawal/bank-transfer"
                  active-class="selected"
                >
                  <ui-check-button
                    :text="$t('bank_transfer')"
                    :img="
                      getAssetImage(
                        'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                      )
                    "
                  />
                </nuxt-link>
                <template v-if="isPaymentBankMethodValible">
                  <nuxt-link
                    v-for="paymentMethod in paymentBanks.PaymentMethodsForWithdrawal"
                    :key="paymentMethod.PaymentMethodId"
                    :to="
                      '/withdrawal/payment-bank/' + paymentMethod.PaymentMethod
                    "
                    active-class="selected"
                  >
                    <ui-check-button
                      :text="paymentMethod.PaymentMethodDisplayName"
                      :img="paymentMethod.PaymentMethodIconUrl"
                    />
                  </nuxt-link>
                </template>
                <nuxt-link
                  v-if="isNormalBankMethodValible && !isUfun"
                  id="withdrawalBankTransferOption"
                  to="/withdrawal/bank-transfer"
                  active-class="selected"
                >
                  <ui-check-button
                    :text="$t('bank_transfer')"
                    :img="
                      getAssetImage(
                        'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                      )
                    "
                  />
                </nuxt-link>
              </div>
            </el-scrollbar>
          </aside>
          <el-scrollbar class="w-9/12" height="724px">
            <div class="divider-y">
              <nuxt-page
                :payment-banks="paymentBanks"
                :normal-banks="normalBanks"
                :profile="profile"
                :is-withdrawal-limit-enabled="isWithdrawalLimitEnabled"
                :is-payment-password-enable="isPaymentPasswordEnable"
              >
              </nuxt-page>
            </div>
          </el-scrollbar>
        </div>
      </template>
    </template>
  </user-center-layout>
  <el-dialog
    v-model="isShowPaymentPasswordDialog"
    :show-close="false"
    :close-on-click-modal="false"
    width="40%"
    custom-class="no-header"
    id="paymentPasswordDialog"
  >
    <div class="mb-4" style="word-break: break-word">
      {{ alertMessage }}
    </div>
    <div>
      <el-form
        ref="ruleFormRef"
        label-position="left"
        label-width="200px"
        :model="formData"
        :rules="getRule"
        style="max-width: 550px"
        :validate-on-rule-change="false"
      >
        <el-form-item :label="paymentPasswordLabel" prop="paymentPassword">
          <el-input id="dialogPaymentPassword" v-model="formData.paymentPassword" type="password" />
        </el-form-item>
        <el-form-item
          :label="confirmPaymentPasswordLabel"
          prop="confirmPaymentPassword"
        >
          <el-input id="dialogPaymentPasswordConfirm" v-model="formData.confirmPaymentPassword" type="password" />
        </el-form-item>
        <el-form-item :label="loginPasswordLabel" prop="loginPassword">
          <el-input id="dialogLoginPassword" v-model="formData.loginPassword" type="password" />
        </el-form-item>
      </el-form>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <div class="text-center">
          <el-button id="dialogCancel" type="danger" round @click="onCancel">{{
            $t("cancel")
          }}</el-button>
          <el-button
            id="dialogSubmit"
            type="primary"
            round
            @click="submitWithdrawal(ruleFormRef)"
            >{{ $t("submit") }}</el-button
          >
        </div>
      </span>
    </template>
  </el-dialog>
</template>

<script lang="ts" setup>
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";

const {
  paymentBanks,
  normalBanks,
  isNormalBankMethodValible,
  isPaymentBankMethodValible,
  paymentPasswordLabel,
  confirmPaymentPasswordLabel,
  loginPasswordLabel,
  alertMessage,
  formData,
  isShowPaymentPasswordDialog,
  submitWithdrawal,
  getRule,
  ruleFormRef,
  isPaymentPasswordEnable,
  profile,
  isWithdrawalLimitEnabled,
  isLoading,
  isBankMethodAvailabled,
  onCancel,
  isUfun,
} = useWithdrawal();
const { getAssetImage } = commonHelper;
</script>
<style scoped>
.uc-section :deep(.el-input__inner),
.uc-section :deep(.el-input-group__append) {
  background-color: var(--background5);
  color: var(--text5);
}
:deep(.company-bank-account .el-input__wrapper) {
  width: 98%;
}
.uc-section :deep(.company-bank-account-container .el-input-group__append) {
  background-color: var(--primary);
  border: unset;
  border-radius: 4px;
  box-shadow: none;
}
.uc-section :deep(.el-form-item__label) {
  color: var(--text5);
}
:deep(.el-radio-button .check-img) {
  bottom: 17px;
}

.uc-section :deep(.el-input.is-disabled .el-input__inner) {
  --el-disabled-bg-color: var(--background1);
  --el-disabled-text-color: rgba(rgb(85, 100, 145), 0.7);
  -webkit-text-fill-color: var(--text5);
  opacity: 0.5;
}

:deep(.el-input__inner::placeholder) {
  color: var(--text5);
  opacity: 0.5;
}
</style>
